//+------------------------------------------------------------------+
//|                                                       Prolon.mq4 |
//|                                                 Copyright  2011 |
//|                                                   Sasha Juravlev |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011"
#property link      "Sasha Juravlev"

extern   double         Lot=0.01;
extern   int            StopLoss=300;                       //  5 
extern   int            TakeProfit=300;                     //  5 
extern   string         IndPrm="---   ---"; 
extern   int            WPR_Period= 20;
extern   int            ma_period=20;
extern   int            width_cannel=33;
extern   int            max_cannel =120;
extern   int            L = 10;

int      Magic=75000000;
string   StrategyName="Prolon";

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
void init()
  {
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void deinit()
  {
   Comment("");
  }
//+------------------------------------------------------------------+
//| function                                                         |
//+------------------------------------------------------------------+
int NewOrder(int Cmd, double nlot, double pr, double sl=0.0, double tp=0.0)
  {
   int tick=0;
   for(int Try=0; Try<3; Try++)
     {
      while(!IsTradeAllowed()) Sleep(100);
      tick=OrderSend(Symbol(),Cmd,nlot,pr,3,sl,tp,StrategyName,Magic,0,CLR_NONE);
      if(tick>0) break;
      Print("#",OrderTicket()," Error: ",GetLastError()," Function: NewOrder(",OrderMagicNumber(),
                                                ",",Cmd,",",nlot,",",pr,",",sl,",",tp,") ",Try);
      Sleep(1000);
     }
   return (tick);
  }
//+------------------------------------------------------------------+
//| function                                                         |
//+------------------------------------------------------------------+
void CloseOrder(double nlot=0)
  {
   double price;
   for(int Try=0; Try<3; Try++)
     {
      while(!IsTradeAllowed()) Sleep(100);
      if(OrderType()==OP_BUY)  price=Bid;
      if(OrderType()==OP_SELL) price=Ask;
      if(OrderClose(OrderTicket(),nlot,price,3,CLR_NONE)) break;
      Print("#",OrderTicket(),"  Error: ",GetLastError()," Function: CloseOrder(",nlot,") ",Try);
      Sleep(1000);
     }
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start()
  {
   if (!IsTradeAllowed()) return;
        
   //   
   static datetime OpenTime=0;
   if (Time[0]==OpenTime) return;
   OpenTime=Time[0];
   
   //   
   double WPRB1=iCustom(Symbol(),0,"WPR_MA_2line",WPR_Period,ma_period,width_cannel,max_cannel,L,0,1);
   double WPRB2=iCustom(Symbol(),0,"WPR_MA_2line",WPR_Period,ma_period,width_cannel,max_cannel,L,0,2);
   double WPRR1=iCustom(Symbol(),0,"WPR_MA_2line",WPR_Period,ma_period,width_cannel,max_cannel,L,1,1);
   double WPRR2=iCustom(Symbol(),0,"WPR_MA_2line",WPR_Period,ma_period,width_cannel,max_cannel,L,1,2);
   double WPRG1=iCustom(Symbol(),0,"WPR_MA_2line",WPR_Period,ma_period,width_cannel,max_cannel,L,2,1);
   double WPRG2=iCustom(Symbol(),0,"WPR_MA_2line",WPR_Period,ma_period,width_cannel,max_cannel,L,2,2);
   int Signal=0; // 1=, 2=
   if (WPRB2<WPRG2 && WPRB1>WPRG1) Signal=1;
   if (WPRB2>WPRR2 && WPRB1<WPRR1) Signal=2;
   if (Signal==0) return;

   //   
   for (int i=OrdersTotal()-1; i>=0; i--)
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
        {
         if (OrderType()==OP_BUY && Signal==2) CloseOrder(OrderLots());
         if (OrderType()==OP_SELL && Signal==1) CloseOrder(OrderLots());
        }

   //   
   if (Signal==1) NewOrder(OP_BUY,Lot,Ask,Ask-StopLoss*Point,Ask+TakeProfit*Point);
   if (Signal==2) NewOrder(OP_SELL,Lot,Bid,Bid+StopLoss*Point,Bid-TakeProfit*Point);
  }
//+------------------------------------------------------------------+